<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Document</title>
</head>

<body>
    <script>
        //Метод forEach вызывает функцию  callback для каждого элемента массива. Функции callback передается 3 параметра: элемент массива, его порядковый номер, и собственно сам массив, котороый перебирают. Сам метод используется только для перебора каждого элемента массива и он ничего не возвращает. Внутрь forEach, как и в цикле for можно поместить любые другие функции или колбеки или методы для реализации  манипуляций с каждым элементом элементом массива. P.S  Несколько закомментированных строк ниже - это мои попытки сделать массив через prompt, однако идея оказалась плохой, так как все значения нового массива arr оказались строками, каковыми их и возвращает prompt. Очевидного способа преобразовать строки в исходные типы данных я не нашел, если вы мне подскажите, буду Вам благодарен:)





        let arr = ['hello', 'world', 23, '23', undefined, true, false, null, {
            name: "Василий",
            age: "37",
            country: "Ukraine"
        }];

        //let stringData = prompt("Перечислите элементы массива через запятую");
        //console.log( typeof stringData);
        //let arr = stringData.split(', ');
        console.log(arr);
        let typeData = prompt("Введите исключаемый тип данных");
        switch (typeData) {
            case 'string':
                alert(`${typeData} data type  was excluded from array`);
                break;
            case 'number':
                typeData = Boolean(typeData);
                typeData = +(typeData);
                alert(`Number data type  was excluded from array`);
                break;
            case 'boolean':
                typeData = Boolean(typeData);
                alert(`Boolean data type  was excluded from array`);
                break;
            case 'null':
                typeData = null;
                alert(`Null was excluded from array`);
                break;
            case 'object':
                typeData = {};
                alert(`Object data type  was excluded from array`);
                break;
            case 'undefined':
                typeData = undefined;
                alert("Значение неприсвоенно.");

            default:
                alert("Вы ввели неверный тип данных или пустую строку ");
        }

        function isFilter(value) {

            return typeof typeData !== typeof value;

        }
        console.log(typeof typeData);
        console.log(isFilter());

        function filterBy(arr) {
            let newArr = arr.filter(isFilter);
            return newArr;
        }

        console.log(filterBy(arr));

    </script>
</body>

</html>
